import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.awt.Font;

public class jinete  extends AnimatedActor
{    
    private int vidas;
    private int numGotas=3;
    private int vSpeed= 0;
    private int acceleration= 5;
    private int jumpStrenght= 80;
    private int nivel=1;
    private int numBolas;
    private int numPuntos;
    private int aux=12;
    
    public jinete(int vi,int ng,int lev,int nB,int nP)
    {
    super("englride", ".png", 8);
    vidas= vi;
    numGotas= ng;
    nivel= lev;
    numBolas= nB;
    numPuntos=nP;
    }
             
    public void act() 
    {      
        
        sobreRoca();        
        siTecla();          
        defineCaida();        
        siChocaLlanta();
        siChocaBarril();           
        siChocaLlave();        
        siChocaPetroleo();
        siChocaLluvia(); 
        retornaVidas();
        siTocaFlecha();
        //siChocaMalhechor();
        //if(nivel==6&&siChocaMalhechor())
        //   ((pradera)getWorld()).winner();
        if(vidas<=0)
            ((pradera)getWorld()).gameOver();
        
        //fall();
    }    
    public void siChocaLlanta()
    {
        Actor a= getOneObjectAtOffset(0,0,llanta.class);
        if(a!=null)
        {
            Greenfoot.playSound("ping.wav");
            vidas= vidas-1;
            setLocation(30,300);
            vSpeed=-35;
        }
    }
    public void fall()
    {
        int y=getY();
        if(y+vSpeed<450)
        {
        setLocation(getX(), getY()+vSpeed);
        vSpeed= vSpeed + acceleration;
        }
        else
        {
            setLocation(getX(),450);
        }
    }
    
    public void siTecla()
    {
        if(Greenfoot.isKeyDown("right"))
        {
        super.act();  // this takes care of the image animation
        //move(6.0);
        move(7.0);
        if(getY()==450||sobreMontaa())
        Greenfoot.playSound("horse2.wav");
        }
        if(Greenfoot.isKeyDown("left"))
        {
        super.act();  // this takes care of the image animation
        move(-7.0);
        if(getY()==450)
        Greenfoot.playSound("horse2.wav");
        }
        if(Greenfoot.isKeyDown("up"))
        {
        super.act();  // this takes care of the image animation
        if(sobreMontaa()||getY()==450 || sobreRoca())
        jump();
        }
        if(Greenfoot.isKeyDown("space")&& numBolas>0)
        {
        World w= getWorld();
        w.addObject(new bola(),getX()+35,getY());
        numBolas= numBolas-1;
        }
    }
    
    public void defineCaida()
    {
        if(sobreMontaa()&& getY()<400 && getY()>380)
        {
            //setLocation(getX(),380);
            vSpeed=0;            
        }
            else
            fall();
    }
    public boolean sobreMontaa()
    {
        //Actor a= getOneIntersectingObject(montaa.class);
        Actor a= getOneObjectAtOffset(0,30,montana2.class);
        //Actor b= getOneIntersectingObject(montaa2.class);
        Actor b= getOneObjectAtOffset(0,30,montana2.class);        
        if((a!=null || b!=null))//&&getY()>370&&getY()<410)
            return true;
        else
            return false;
    }
    
    public void jump()
    {
        vSpeed= -35;
        fall();
    }
    
    public void siTocaFlecha()
    {
        
        Actor a= getOneIntersectingObject(flecha.class);
        if(a!=null)
            {
                //World wo= getWorld();
                //pradera p= new pradera();
                //((pradera)getWorld()).nivel2();
                nivel= nivel+1;
                ((pradera)getWorld()).seleccionaNivel(nivel,vidas,numGotas,numBolas);
                //setLocation(20,450);
            }
    }
    
    public void siChocaBarril()
    {
        Actor bar= getOneIntersectingObject(barril.class);
        if(bar!=null)
        {
            numBolas= 3;
            World w= getWorld();
            w.removeObject(bar);
            numPuntos= numPuntos + 10;
        }
    }
    public boolean sobreRoca()
    {
        Actor c= getOneObjectAtOffset(10,40,roca.class);
        //Actor c= getOneIntersectingObject(roca.class);
        if(c!=null)
        {
            vSpeed=0;
            return true;
        }
        else 
            return false;
    }
    
    public void siChocaLlave()
    {
        Actor d= getOneIntersectingObject(llave.class);
        if(d!=null)
        { 
            int x= d.getX();
            int y= d.getY();
            World w= getWorld();
            w.removeObject(d);
            w.addObject(new llave2(),x,y);
            numPuntos= numPuntos + 20;
        }
    }
    public void siChocaPetroleo()
    {
        Actor d= getOneObjectAtOffset(20,0,petroleo.class);
        if(d!=null)
        {
            Greenfoot.playSound("ping.wav");
            vidas= vidas-1;
            setLocation(30,300);
            vSpeed=-35;
        }
    }
    public void siChocaLluvia()
    {
        Actor e= getOneIntersectingObject(gota.class);
        if(e!=null)
        {
            Greenfoot.playSound("ping.wav");
            numGotas=numGotas-1;
            if(numGotas<=0)
            {
                vidas=vidas-1;
                numGotas=3;
                setLocation(30,300);                
            }
            World w= getWorld();
            w.removeObject(e);
        }
    }
    public void siChocaMalhechor()
    {
        Actor f= getOneIntersectingObject(malhechor.class);
        if(f!=null)
        {
            ((pradera)getWorld()).winner();            
        }
    }
    
    
    public void retornaVidas()
    {
        ((pradera)getWorld()).retornaVidass(vidas);
    }
    
    
}
